/// Merge Sort - Sortarea prin INterclasare
/// Complexitate: O(n * log n)
#include <fstream>
using namespace std;

ifstream fin("sir.in");
ofstream fout("sir.out");

const int MaxN = 1000;
int a[MaxN], n;

void ReadArray();
void Merge(int st, int dr);
void Interclass(int st, int m, int dr);
void WriteArray();

int main()
{
    ReadArray();
    Merge(0, n - 1);
    WriteArray();

    fin.close();
    fout.close();
}

void Merge(int st, int dr)
{
    if (st == dr) return;
    int m = (st + dr) / 2;
    Merge(st, m);
    Merge(m + 1, dr);
    Interclass(st, m, dr);
}

void Interclass(int st, int m, int dr)
{
    int tmp[MaxN];
    int i = st, j = m + 1, k = 0;
    while (i <= m && j <= dr)
        if (a[i] < a[j])
            tmp[k++] = a[i++];
        else
            tmp[k++] = a[j++];

    while (i <= m)
        tmp[k++] = a[i++];
    while (j <= dr)
        tmp[k++] = a[j++];

    for (int i = st; i <= dr; ++i)
        a[i] = tmp[i - st];
}

void ReadArray()
{
    fin >> n;
    for (int i = 0; i < n; ++i)
        fin >> a[i];
}

void WriteArray()
{
    for (int i = 0; i < n; ++i)
        fout << a[i] << ' ';
}
