/// Merge Sort - Sortarea prin INterclasare
/// Complexitate: O(n * log n)
#include <fstream>
using namespace std;

const int MaxN = 1000;

void ReadArray(int a[], int& n);
void Merge(int st, int dr, int a[]);
void Interclass(int st, int m, int dr, int a[]);
void WriteArray(int a[], int n);

int main()
{
    int a[MaxN], n;
    ReadArray(a, n);
    Merge(0, n - 1, a);
    WriteArray(a, n);

}

void Merge(int st, int dr, int a[])
{
    if (st == dr) return;
    int m = (st + dr) / 2;
    Merge(st, m, a);
    Merge(m + 1, dr, a);
    Interclass(st, m, dr, a);
}

void Interclass(int st, int m, int dr, int a[])
{
    int tmp[MaxN];
    int i = st, j = m + 1, k = 0;
    while (i <= m && j <= dr)
        if (a[i] < a[j])
            tmp[k++] = a[i++];
        else
            tmp[k++] = a[j++];

    while (i <= m)
        tmp[k++] = a[i++];
    while (j <= dr)
        tmp[k++] = a[j++];

    for (int i = st; i <= dr; ++i)
        a[i] = tmp[i - st];
}

void ReadArray(int a[], int& n)
{
    ifstream fin("sir.in");
    fin >> n;
    for (int i = 0; i < n; ++i)
        fin >> a[i];
    fin.close();
}

void WriteArray(int a[], int n)
{
    ofstream fout("sir.out");
    for (int i = 0; i < n; ++i)
        fout << a[i] << ' ';
    fout.close();
}
