// Quick Sort
// O(n * log n) - time complexity

#include <fstream>
using namespace std;

#define DIM 10000
int a[DIM], n;

void Read();
void Write();
void Quick(int st, int dr);

int main()
{
	Read();
	Quick(1, n);
	Write();
}

void Read()
{
	ifstream fin("sir.in");
	fin >> n; 
	for ( int i = 1; i <= n; i++ )
		fin >> a[i];
	fin.close();
}

void Quick(int st, int dr) // O(n * log2 n)
{
	int pivot = a[(st + dr) / 2];
	int i = st, j = dr;
	do
	{
		while ( a[i] < pivot ) i++;
		while ( a[j] > pivot ) j--;
		if ( i <= j )
		{
			int aux = a[i];
			a[i] = a[j];
			a[j] = aux;
			i++;
			j--;
		}
	} while ( i <= j );

	if ( st < j ) Quick(st, j);
	if ( i < dr ) Quick(i, dr);
}

void Write()
{
	ofstream fout("sir.out");
	for ( int i = 1; i <= n; i++ )
		fout << a[i] << " ";
	fout.close();
}

